/***************************************************************************
 *   Copyright (C) 2006, IBM                                               *
 *                                                                         *
 *   Maintained By:                                                        *
 *   Eric Munson and Brad Peters                                           *
 *   munsone@us.ibm.com, bpeters@us.ibm.com                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the Lesser GNU General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the  *
 *   License, or at your option) any later version.                        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the Lesser GNU General Public      *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include <libvpd-1/helper_functions.h>

using namespace std;
using namespace lsvpd;

	/* Caller responsible for freeing malloc'd memory */
	void HelperFunctions::str2chr(char **str1, string& str2)
		{
			int i;
			*str1 = (char *)malloc(str2.length() * sizeof(char));
			
			i=0;
			while (i < str2.length())
			{
				(*str1)[i] = str2[i];
				i++;		
			}
				
			(*str1)[i] = '\0';	
		}
		
	/* Caller responsible for freeing malloc'd memory */
	void HelperFunctions::str2chr(char **str1, const string& str2)
		{
			int i;
			*str1 = (char *)malloc((str2.length() + 1) * sizeof(char));
			
			i=0;
			while (i < str2.length())
			{ 
				(*str1)[i] = str2[i];
				i++;
			}
			
			(*str1)[i] = '\0';	
		}
	
	/* @brief Ensure a passed in fs path arg is in reasonable format */
	void HelperFunctions::fs_fixPath(string str)
	{
		int i = str.length();
		
		while (str[i] == '\0')
			i--;
		if (str[i] == '/')
			str[i] = '\0';		
	}
	
	/* @brief Ensure a passed in fs path arg is in reasonable format */
	char *HelperFunctions::fs_fixPath(char *path_t)
	{
		char *path;
		char *chr;
		int i;
		
		path = strdup(path_t);
		/* Basic wierdness checking*/		
			chr = &path[strlen(path)];			
			while (chr != '\0') 
				chr--;
			if (*chr == '/')
				*chr = '\0';					
					
		return path;
	}

	int HelperFunctions::countChar( const string& str, char c )
	{
		string::const_iterator i, end;
		int ret = 0;
		for( i = str.begin( ), end = str.end( ); i != end; ++i )
		{
			if( (*i) == c )
			{
				ret++;
			}
		}
		return ret;
	}
